UIPackage
Menu

Framework

Change language

Boilerplate repo

Signature Pad

signature-pad ui
Boilerplate repo

Canvas-based digital signature capture with pointer events (mouse + touch). The value is a PNG data URL, with pen color/thickness, background, clear method, disabled/readonly states, and a live point count.

Also available for Vue ->

Installation

$ npx shadcn@latest add https://uipkge.dev/r/react/signature-pad.json
Named registry: npx shadcn@latest add @uipkge-react/signature-pad Installs to: components/ui/signature-pad/

Examples

Loading interactive previews…

Props

Name Type / Values Default Required
modelValue

React equivalent of the Vue `v-model` binding — pair with `onModelChange`.

string | null optional
width number optional
height number optional
penColor string optional
penThickness number optional
backgroundColor string optional
exportFormat string optional
disabled boolean optional
readonly boolean optional
showClearButton boolean optional
clearLabel string optional
onModelChange

Fired with the new data URL (or null) whenever the signature changes.

(value: string | null) => void optional
onBegin

Fired when a stroke begins.

() => void optional
onEnd

Fired when a stroke ends.

() => void optional
onChange

Fired with the new data URL (or null) on every change (same payload as onModelChange).

(value: string | null) => void optional
actions

Render-prop for custom action controls. Mirrors the Vue `actions` slot.

(state: { clear: () => void; exportSignature: () => void; empty: boolean }) => React.ReactNode optional

Schema

Type aliases from this item's source — use them to shape the data you pass in.

SignaturePadRef
interface SignaturePadRef {
  clear: () => void
  exportSignature: () => void
  toDataURL: () => void
  pointCount: number
  isEmpty: boolean
}

Files installed (3)

  • components/ui/signature-pad/SignaturePad.tsx 9.2 kB
    import * as React from 'react'
    import { Eraser } from 'lucide-react'
    import { cn } from '@/lib/utils'
    import { signaturePadVariants } from './signature-pad.variants'
    
    export interface SignaturePadProps extends Omit<React.HTMLAttributes<HTMLDivElement>, 'onChange'> {
      /** PNG data URL of the current canvas contents, or null when empty. The
       *  React equivalent of the Vue `v-model` binding — pair with `onModelChange`. */
      modelValue?: string | null
      width?: number
      height?: number
      penColor?: string
      penThickness?: number
      backgroundColor?: string
      exportFormat?: string
      disabled?: boolean
      readonly?: boolean
      showClearButton?: boolean
      clearLabel?: string
      /** Fired with the new data URL (or null) whenever the signature changes. */
      onModelChange?: (value: string | null) => void
      /** Fired when a stroke begins. */
      onBegin?: () => void
      /** Fired when a stroke ends. */
      onEnd?: () => void
      /** Fired with the new data URL (or null) on every change (same payload as onModelChange). */
      onChange?: (value: string | null) => void
      /** Render-prop for custom action controls. Mirrors the Vue `actions` slot. */
      actions?: (state: { clear: () => void; exportSignature: () => void; empty: boolean }) => React.ReactNode
    }
    
    export interface SignaturePadRef {
      clear: () => void
      exportSignature: () => void
      toDataURL: () => void
      pointCount: number
      isEmpty: boolean
    }
    
    /** Resolve theme CSS variables (and legacy `hsl(var(--x))`) to a paint color canvas accepts. */
    function resolveColor(input: string | undefined, cssVar: string): string {
      let candidate = (input || '').trim()
      if (!candidate) candidate = `var(${cssVar})`
      const hslWrapped = candidate.match(/^hsl\(\s*(var\(--[^)]+\))\s*\)$/i)
      if (hslWrapped) candidate = hslWrapped[1]
      if (candidate.startsWith('var(')) {
        const name = candidate.match(/var\((--[^),]+)/)?.[1]
        if (name && typeof document !== 'undefined') {
          const v = getComputedStyle(document.documentElement).getPropertyValue(name).trim()
          if (v) return v
        }
      }
      return candidate
    }
    
    const SignaturePad = React.forwardRef<SignaturePadRef, SignaturePadProps>(
      (
        {
          modelValue,
          width = 400,
          height = 200,
          // Empty → resolve --foreground / --background (theme-aware; works in dark mode).
          penColor = '',
          penThickness = 2,
          backgroundColor = '',
          exportFormat = 'image/png',
          disabled = false,
          readonly = false,
          showClearButton = true,
          clearLabel = 'Clear',
          className,
          onModelChange,
          onBegin,
          onEnd,
          onChange,
          actions,
          ...props
        },
        ref,
      ) => {
        const canvasRef = React.useRef<HTMLCanvasElement | null>(null)
        const ctxRef = React.useRef<CanvasRenderingContext2D | null>(null)
        const isDrawingRef = React.useRef(false)
        const lastPosRef = React.useRef({ x: 0, y: 0 })
        // Sync ref so export on pointer-up sees ink set in the same event turn
        // (React state would still be stale until the next render).
        const hasInkRef = React.useRef(false)
    
        const [pointCount, setPointCount] = React.useState(0)
        const [hasInk, setHasInk] = React.useState(false)
    
        // Keep the latest callbacks without re-running the canvas setup effect.
        const callbacksRef = React.useRef({ onModelChange, onBegin, onEnd, onChange })
        callbacksRef.current = { onModelChange, onBegin, onEnd, onChange }
    
        const isInteractive = !disabled && !readonly
    
        const setupCanvas = React.useCallback(() => {
          const canvas = canvasRef.current
          if (!canvas) return
          const dpr = window.devicePixelRatio || 1
          canvas.width = width * dpr
          canvas.height = height * dpr
          canvas.style.width = `${width}px`
          canvas.style.height = `${height}px`
          const context = canvas.getContext('2d')
          if (!context) return
          context.scale(dpr, dpr)
          context.lineCap = 'round'
          context.lineJoin = 'round'
          context.strokeStyle = resolveColor(penColor, '--foreground')
          context.lineWidth = penThickness
          context.fillStyle = resolveColor(backgroundColor, '--background')
          context.fillRect(0, 0, width, height)
          ctxRef.current = context
          setPointCount(0)
          hasInkRef.current = false
          setHasInk(false)
        }, [width, height, penColor, penThickness, backgroundColor])
    
        const getPointerPos = React.useCallback(
          (e: React.PointerEvent<HTMLCanvasElement>) => {
            const canvas = canvasRef.current
            if (!canvas) return { x: 0, y: 0 }
            const rect = canvas.getBoundingClientRect()
            // Map CSS pixels → logical canvas coords if the element is CSS-scaled.
            const scaleX = width / (rect.width || width)
            const scaleY = height / (rect.height || height)
            return {
              x: (e.clientX - rect.left) * scaleX,
              y: (e.clientY - rect.top) * scaleY,
            }
          },
          [width, height],
        )
    
        const exportSignature = React.useCallback(() => {
          const canvas = canvasRef.current
          if (!canvas) return
          const { onModelChange, onChange } = callbacksRef.current
          if (!hasInkRef.current) {
            onModelChange?.(null)
            onChange?.(null)
            return
          }
          const dataUrl = canvas.toDataURL(exportFormat)
          onModelChange?.(dataUrl)
          onChange?.(dataUrl)
        }, [exportFormat])
    
        const clear = React.useCallback(() => {
          const canvas = canvasRef.current
          const context = ctxRef.current
          if (!canvas || !context) return
          context.fillStyle = resolveColor(backgroundColor, '--background')
          context.fillRect(0, 0, width, height)
          setPointCount(0)
          hasInkRef.current = false
          setHasInk(false)
          callbacksRef.current.onModelChange?.(null)
          callbacksRef.current.onChange?.(null)
        }, [backgroundColor, width, height])
    
        React.useImperativeHandle(
          ref,
          (): SignaturePadRef => ({
            clear,
            exportSignature,
            toDataURL: exportSignature,
            pointCount,
            isEmpty: !hasInk,
          }),
          [clear, exportSignature, pointCount, hasInk],
        )
    
        React.useEffect(() => {
          setupCanvas()
          return () => {
            ctxRef.current = null
          }
        }, [setupCanvas])
    
        // modelValue is read-only from the outside; we do not paint it back onto
        // the canvas (mirrors the Vue component, which also never restores ink).
    
        const handlePointerDown = (e: React.PointerEvent<HTMLCanvasElement>) => {
          if (!isInteractive || !ctxRef.current) return
          e.preventDefault()
          isDrawingRef.current = true
          const { x, y } = getPointerPos(e)
          lastPosRef.current = { x, y }
          ctxRef.current.beginPath()
          ctxRef.current.moveTo(x, y)
          setPointCount((c) => c + 1)
          hasInkRef.current = true
          setHasInk(true)
          callbacksRef.current.onBegin?.()
          canvasRef.current?.setPointerCapture(e.pointerId)
        }
    
        const handlePointerMove = (e: React.PointerEvent<HTMLCanvasElement>) => {
          if (!isDrawingRef.current || !ctxRef.current) return
          e.preventDefault()
          const { x, y } = getPointerPos(e)
          const { x: lastX, y: lastY } = lastPosRef.current
          ctxRef.current.beginPath()
          ctxRef.current.moveTo(lastX, lastY)
          ctxRef.current.lineTo(x, y)
          ctxRef.current.stroke()
          lastPosRef.current = { x, y }
          setPointCount((c) => c + 1)
        }
    
        const handlePointerUp = (e: React.PointerEvent<HTMLCanvasElement>) => {
          if (!isDrawingRef.current) return
          isDrawingRef.current = false
          ctxRef.current?.closePath()
          canvasRef.current?.releasePointerCapture(e.pointerId)
          exportSignature()
          callbacksRef.current.onEnd?.()
        }
    
        return (
          <div
            data-uipkge=""
            data-slot="signature-pad"
            data-disabled={disabled ? '' : undefined}
            data-readonly={readonly ? '' : undefined}
            className={cn(signaturePadVariants(), className)}
            {...props}
          >
            <canvas
              ref={canvasRef}
              className={cn('block touch-none rounded-md', !isInteractive && 'pointer-events-none')}
              style={{ touchAction: 'none' }}
              aria-label={`Signature pad${disabled ? ' (disabled)' : readonly ? ' (readonly)' : ''}`}
              aria-disabled={disabled || undefined}
              role="img"
              onPointerDown={handlePointerDown}
              onPointerMove={handlePointerMove}
              onPointerUp={handlePointerUp}
              onPointerCancel={handlePointerUp}
              onPointerLeave={handlePointerUp}
            />
            {showClearButton && isInteractive ? (
              <div className="flex items-center justify-between gap-2 pt-2">
                <span className="text-muted-foreground text-xs tabular-nums">{pointCount} points</span>
                <button
                  type="button"
                  className="text-muted-foreground hover:text-foreground focus-visible:ring-ring inline-flex items-center gap-1 rounded-md text-xs transition-colors focus-visible:ring-2 focus-visible:outline-none disabled:pointer-events-none disabled:opacity-50"
                  disabled={!hasInk}
                  onClick={clear}
                >
                  <Eraser className="size-4" />
                  {clearLabel}
                </button>
              </div>
            ) : null}
            {actions ? actions({ clear, exportSignature, empty: !hasInk }) : null}
          </div>
        )
      },
    )
    SignaturePad.displayName = 'SignaturePad'
    
    export { SignaturePad }
  • components/ui/signature-pad/signature-pad.variants.ts 0.3 kB
    import type { VariantProps } from 'class-variance-authority'
    import { cva } from 'class-variance-authority'
    
    export const signaturePadVariants = cva(
      'border-input bg-background inline-flex flex-col gap-1 rounded-lg border p-2 shadow-xs',
    )
    
    export type SignaturePadVariants = VariantProps<typeof signaturePadVariants>
  • components/ui/signature-pad/index.ts 0.2 kB
    export { SignaturePad, type SignaturePadProps, type SignaturePadRef } from './SignaturePad'
    export { signaturePadVariants, type SignaturePadVariants } from './signature-pad.variants'

Raw manifest: https://uipkge.dev/r/react/signature-pad.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Signature Pad

signature-pad ui
Boilerplate repo

Canvas-based digital signature capture with pointer events (mouse + touch). v-model emits a PNG data URL, with pen color/thickness, background, clear method, disabled/readonly states, and a live point count.

Also available for React ->

Installation

$ npx shadcn-vue@latest add https://uipkge.dev/r/vue/signature-pad.json
Named registry: npx shadcn-vue@latest add @uipkge/signature-pad Installs to: app/components/ui/signature-pad/

Examples

Loading interactive previews…

Props

Name Type / Values Default Required
modelValue string | null null optional
width number 400 optional
height number 200 optional
penColor string optional
penThickness number 2 optional
backgroundColor string '' optional
exportFormat string 'image/png' optional
disabled boolean false optional
readonly boolean false optional
showClearButton boolean true optional
clearLabel string 'Clear' optional
class HTMLAttributes['class'] optional

Files installed (3)

  • app/components/ui/signature-pad/SignaturePad.vue 6.6 kB
    <script setup lang="ts">
    import type { HTMLAttributes } from 'vue'
    import { computed, onBeforeUnmount, onMounted, ref, watch } from 'vue'
    import { Eraser } from 'lucide-vue-next'
    import { cn } from '@/lib/utils'
    import { signaturePadVariants } from './signature-pad.variants'
    
    interface Props {
      modelValue?: string | null
      width?: number
      height?: number
      penColor?: string
      penThickness?: number
      backgroundColor?: string
      exportFormat?: string
      disabled?: boolean
      readonly?: boolean
      showClearButton?: boolean
      clearLabel?: string
      class?: HTMLAttributes['class']
    }
    
    const props = withDefaults(defineProps<Props>(), {
      modelValue: null,
      width: 400,
      height: 200,
      // Theme tokens are OKLCH (`--foreground` / `--background`). Resolve via
      // getComputedStyle — canvas cannot parse `hsl(var(--…))` or bare `var(--…)`.
      penColor: '',
      penThickness: 2,
      backgroundColor: '',
      exportFormat: 'image/png',
      disabled: false,
      readonly: false,
      showClearButton: true,
      clearLabel: 'Clear',
    })
    
    const emit = defineEmits<{
      'update:modelValue': [value: string | null]
      begin: []
      end: []
      change: [value: string | null]
    }>()
    
    const canvasRef = ref<HTMLCanvasElement | null>(null)
    const isDrawing = ref(false)
    const pointCount = ref(0)
    const hasInk = ref(false)
    const ctx = ref<CanvasRenderingContext2D | null>(null)
    let lastX = 0
    let lastY = 0
    
    const isInteractive = computed(() => !props.disabled && !props.readonly)
    
    /** Resolve theme CSS variables (and legacy `hsl(var(--x))`) to a paint color canvas accepts. */
    function resolveColor(input: string | undefined, cssVar: string): string {
      let candidate = (input || '').trim()
      if (!candidate) candidate = `var(${cssVar})`
      // Legacy shadcn hsl() wrapper around a CSS variable — unwrap.
      const hslWrapped = candidate.match(/^hsl\(\s*(var\(--[^)]+\))\s*\)$/i)
      if (hslWrapped) candidate = hslWrapped[1]
      if (candidate.startsWith('var(')) {
        const name = candidate.match(/var\((--[^),]+)/)?.[1]
        if (name && typeof document !== 'undefined') {
          const v = getComputedStyle(document.documentElement).getPropertyValue(name).trim()
          if (v) return v
        }
      }
      return candidate
    }
    
    function setupCanvas() {
      const canvas = canvasRef.value
      if (!canvas) return
      const dpr = window.devicePixelRatio || 1
      canvas.width = props.width * dpr
      canvas.height = props.height * dpr
      canvas.style.width = `${props.width}px`
      canvas.style.height = `${props.height}px`
      const context = canvas.getContext('2d')
      if (!context) return
      context.scale(dpr, dpr)
      context.lineCap = 'round'
      context.lineJoin = 'round'
      context.strokeStyle = resolveColor(props.penColor, '--foreground')
      context.lineWidth = props.penThickness
      context.fillStyle = resolveColor(props.backgroundColor, '--background')
      context.fillRect(0, 0, props.width, props.height)
      ctx.value = context
      pointCount.value = 0
      hasInk.value = false
    }
    
    function getPointerPos(e: PointerEvent): { x: number; y: number } {
      const canvas = canvasRef.value
      if (!canvas) return { x: 0, y: 0 }
      const rect = canvas.getBoundingClientRect()
      // Map CSS pixels → logical canvas coords if the element is CSS-scaled.
      const scaleX = props.width / (rect.width || props.width)
      const scaleY = props.height / (rect.height || props.height)
      return {
        x: (e.clientX - rect.left) * scaleX,
        y: (e.clientY - rect.top) * scaleY,
      }
    }
    
    function startDraw(e: PointerEvent) {
      if (!isInteractive.value || !ctx.value) return
      e.preventDefault()
      isDrawing.value = true
      const { x, y } = getPointerPos(e)
      lastX = x
      lastY = y
      ctx.value.beginPath()
      ctx.value.moveTo(x, y)
      pointCount.value += 1
      hasInk.value = true
      emit('begin')
      canvasRef.value?.setPointerCapture(e.pointerId)
    }
    
    function draw(e: PointerEvent) {
      if (!isDrawing.value || !ctx.value) return
      e.preventDefault()
      const { x, y } = getPointerPos(e)
      ctx.value.beginPath()
      ctx.value.moveTo(lastX, lastY)
      ctx.value.lineTo(x, y)
      ctx.value.stroke()
      lastX = x
      lastY = y
      pointCount.value += 1
    }
    
    function endDraw(e: PointerEvent) {
      if (!isDrawing.value) return
      isDrawing.value = false
      if (ctx.value) ctx.value.closePath()
      canvasRef.value?.releasePointerCapture(e.pointerId)
      exportSignature()
      emit('end')
    }
    
    function exportSignature() {
      const canvas = canvasRef.value
      if (!canvas) return
      if (!hasInk.value) {
        emit('update:modelValue', null)
        emit('change', null)
        return
      }
      const dataUrl = canvas.toDataURL(props.exportFormat)
      emit('update:modelValue', dataUrl)
      emit('change', dataUrl)
    }
    
    function clear() {
      const canvas = canvasRef.value
      const context = ctx.value
      if (!canvas || !context) return
      context.fillStyle = resolveColor(props.backgroundColor, '--background')
      context.fillRect(0, 0, props.width, props.height)
      pointCount.value = 0
      hasInk.value = false
      emit('update:modelValue', null)
      emit('change', null)
    }
    
    defineExpose({
      clear,
      exportSignature,
      toDataURL: exportSignature,
      pointCount: computed(() => pointCount.value),
      isEmpty: computed(() => !hasInk.value),
    })
    
    onMounted(() => {
      setupCanvas()
    })
    
    onBeforeUnmount(() => {
      ctx.value = null
    })
    
    watch(
      () => [props.penColor, props.penThickness, props.backgroundColor, props.width, props.height],
      () => {
        setupCanvas()
      },
    )
    </script>
    
    <template>
      <div
        data-uipkge
        data-slot="signature-pad"
        :data-disabled="disabled ? '' : undefined"
        :data-readonly="readonly ? '' : undefined"
        :class="cn(signaturePadVariants(), props.class)"
      >
        <canvas
          ref="canvasRef"
          :class="cn('block touch-none rounded-md', !isInteractive && 'pointer-events-none')"
          :style="{ touchAction: 'none' }"
          :aria-label="'Signature pad' + (disabled ? ' (disabled)' : readonly ? ' (readonly)' : '')"
          :aria-disabled="disabled || undefined"
          role="img"
          @pointerdown="startDraw"
          @pointermove="draw"
          @pointerup="endDraw"
          @pointercancel="endDraw"
          @pointerleave="endDraw"
        />
        <div v-if="showClearButton && isInteractive" class="flex items-center justify-between gap-2 pt-2">
          <span class="text-muted-foreground text-xs tabular-nums">{{ pointCount }} points</span>
          <button
            type="button"
            class="text-muted-foreground hover:text-foreground focus-visible:ring-ring inline-flex items-center gap-1 rounded-md text-xs transition-colors focus-visible:ring-2 focus-visible:outline-none disabled:pointer-events-none disabled:opacity-50"
            :disabled="!hasInk"
            @click="clear"
          >
            <Eraser class="size-4" />
            {{ clearLabel }}
          </button>
        </div>
        <slot name="actions" :clear="clear" :export="exportSignature" :empty="!hasInk" />
      </div>
    </template>
  • app/components/ui/signature-pad/signature-pad.variants.ts 0.3 kB
    import type { VariantProps } from 'class-variance-authority'
    import { cva } from 'class-variance-authority'
    
    export const signaturePadVariants = cva(
      'border-input bg-background inline-flex flex-col gap-1 rounded-lg border p-2 shadow-xs',
    )
    
    export type SignaturePadVariants = VariantProps<typeof signaturePadVariants>
  • app/components/ui/signature-pad/index.ts 0.1 kB
    export { default as SignaturePad } from './SignaturePad.vue'
    export { signaturePadVariants, type SignaturePadVariants } from './signature-pad.variants'

Raw manifest: https://uipkge.dev/r/vue/signature-pad.json